//+------------------------------------------------------------------+
//|                                             Compuforex_Trail.mq4 |
//|                            Copyright  2010, www.compu-forex.com |
//|                                              www.compu-forex.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, www.compu-forex.com"
#property link      "www.compu-forex.com"

#include <stdlib.mqh>
#include <stderror.mqh>

//---- input parameters
extern int        MagicNumber    = -1;
//extern bool       Enable_Trade    = false;
extern bool       Own_Symbol_Only = true;
extern string     Note1          = "Trail_Start $ Trail_Max are pip values";
extern double     Trail_Start    = 12;
extern double     Trail_Max      = 50;
extern string     Note2          = "Bigger Trail % = longer trail";
extern string     Note3          = "Trail_Percent & Trail_Min are % values";
extern double     Trail_Percent  = 75;
extern double     Trail_Min      = 10;
extern bool       Use_Decay      = true;
extern string     Note4          = "Decay rate reduces Trail_Percent per bar";
extern double     Decay_Rate     = 0.8;
extern bool       Exp_Decay      = true;
extern int        Wait_Mins      = 90;
extern string     Note5         = "----------StopLoss Settings---------";
extern bool       Set_SL         = true;
extern bool       SL_Overide     = false;
extern string     Note6          = "Manual_SL will set SL to x pips and overides ALL other StopLoss settings";
extern string     Note7          = "Set Manual_SL to 0 to use auto calculated SL";
extern int        Set_SL_Delay   = 0;
extern double     Manual_SL      = 0;
extern double     SL_Buffer      = 20;
extern int        SL_Minutes     = 240;
extern double     SL_Max         = 60;
extern string     Note8          = "Risk % will overide use of High/Low bars to determine SL";
extern bool       Use_RiskPercent_SL = false;
extern double     Risk           = 1;
extern string     Note9          = "----------General Settings----------";
extern bool       Audio_Alert    = true;
extern bool       Show_Info      = true;

int
   D_Factor = 1,
   Trade_Info[][4],
   SL_Bars;
double   
   Stop_Level,
   Min_Mod        = 0.5;
color
   Text_Color = White;
string
   Orders_Filename,
   ID = "CfTM_";


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
{
   if(Digits==3||Digits==5){D_Factor=10;}
//----
   Orders_Filename = StringConcatenate(WindowExpertName(),"_Ordersfile.csv");
   Print("Calling Load_Orders().....");
   int Loaded_Orders = Load_Orders();
   if(!Loaded_Orders){
      //Create_OrderState();
      int Num_Orders_Saved = Save_Orders();
      Print("Order matrix re-created...." + Num_Orders_Saved + " orders saved to file.");
   }
   else Print("Orders file loaded....." + Loaded_Orders + " orders found.");
   if(Show_Info)Permanent_Display();
   SL_Minutes = MathRound(SL_Minutes/5);
   Print("Init Complete..........");
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   DeleteExistingLabels();
   Save_Orders();
   if(IsTesting())FileDelete(Orders_Filename);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{

bool
   mod,
   Profit_Order;
double
   l_Trail_Start,
   l_Trail_Max,
   l_Min_Mod,
   My_Profit,
   My_Trail,
   My_SL,
   l_Trail_Percent,
   Pip,
   Auto_Trail_Start;
int
   Bar_Shift,
   err;

//----
   //Print("Trade_Count() = " + Trade_Count() + "/ArrayRange(Trade_Info,0) = " + ArrayRange(Trade_Info,0));
   if(Trade_Count()>ArrayRange(Trade_Info,0))Add_Ticket();
   if(Trade_Count()<ArrayRange(Trade_Info,0))Delete_Ticket();

   if(Set_SL)Set_StopLoss();
   //for(int ta = 0;ta<ArrayRange(Trade_Info,0);ta++)Print("Trade array = " + Trade_Info[ta][0] + "/" + Trade_Info[ta][1]+ "/" + Trade_Info[ta][2] + "/" + Trade_Info[ta][4]);
   for (int i=OrdersTotal()-1;i>=0;i--){
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(Own_Symbol_Only){
            if(OrderSymbol()!=Symbol())continue;
         }
         Pip = MarketInfo(OrderSymbol(),MODE_POINT)*D_Factor;
         mod=true;
         if(Trail_Start==0){
            Auto_Trail_Start = iATR(OrderSymbol(),PERIOD_M15,14,1)/Pip;
            l_Trail_Start     = MathSqrt(Auto_Trail_Start) * 4;
            l_Trail_Start *= Pip;
         }
         else l_Trail_Start     = Trail_Start * Pip;
         l_Trail_Max    = Trail_Max * Pip;
         l_Min_Mod      = Min_Mod * Pip;
         Stop_Level = MarketInfo(Symbol(),MODE_STOPLEVEL)/D_Factor;
         Stop_Level *= Pip;
         if(OrderMagicNumber()==MagicNumber||MagicNumber==-1){
            l_Trail_Percent = Get_Trail_Percent(OrderTicket(),OrderSymbol());
            RefreshRates();
            switch(OrderType()){
               case OP_BUY :  My_Profit = OrderClosePrice() - OrderOpenPrice();
                              My_Trail = MathMin(My_Profit * (l_Trail_Percent/100),l_Trail_Max);
                              My_Trail = MathMax(My_Trail,Stop_Level);
                              My_SL = NormalizeDouble(OrderClosePrice()-My_Trail,Digits);
                              if(My_Profit > l_Trail_Start){
                                 Update_Info(OrderTicket());
                                 if(OrderStopLoss() == 0)mod = OrderModify(OrderTicket(),OrderOpenPrice(),My_SL,OrderTakeProfit(),0, CLR_NONE);
                                 else{
                                    if(My_SL-OrderStopLoss() > l_Min_Mod)mod = OrderModify(OrderTicket(),OrderOpenPrice(),My_SL,OrderTakeProfit(),0, CLR_NONE);
                                 }
                              }
                              break;
                        
               case OP_SELL : My_Profit = OrderOpenPrice() - OrderClosePrice();
                              My_Trail = MathMin(My_Profit * (l_Trail_Percent/100),l_Trail_Max);
                              My_Trail = MathMax(My_Trail,Stop_Level);
                              My_SL = NormalizeDouble(OrderClosePrice()+My_Trail,Digits);
                              if(My_Profit > l_Trail_Start){
                                 Update_Info(OrderTicket());
                                 if(OrderStopLoss() == 0)mod = OrderModify(OrderTicket(),OrderOpenPrice(),My_SL,OrderTakeProfit(),0, CLR_NONE);
                                 else{
                                    if(OrderStopLoss()-My_SL > l_Min_Mod)mod = OrderModify(OrderTicket(),OrderOpenPrice(),My_SL,OrderTakeProfit(),0,CLR_NONE);
                                 }
                              }
                              break;
            }
            if(!mod){
               err = GetLastError();
               Print("Error entering Trailing Stop - Error (" + err + ") " + ErrorDescription(err));
            }
         }
      }
      else {
         err = GetLastError();
         Print("Error selecting order in Trailing_Stop function. Error " + err+ " - " + ErrorDescription(err));
      }
   } 
   if(Trade_Count()>ArrayRange(Trade_Info,0))Add_Ticket();
   if(Trade_Count()<ArrayRange(Trade_Info,0))Delete_Ticket();
   Save_Orders();
   if(!Show_Info)return(0);
   CreateTextLable("Trade_No2","Trade Status",Text_Color,80,80);
   CreateTextLable("Trade_No2_Und","______________",Text_Color,70,82);
   CreateTextLable("Trade_No","Number of Open Trades : " + Trade_Count(),Text_Color,0,100);
   if(!Trade_Count()){
      Clean_Up();
      CreateTextLable("Trade_No","No Open trades for us at the moment.........",Text_Color,0,100);
      return;
   }
   Profit_Order=false;
   for(int t = 0;t<ArrayRange(Trade_Info,0);t++){
      if(Trade_Info[t][1]>0)Profit_Order=true;
   }
   string label_name,label_name2,label_name3,label_name4;
   Clean_Up();
   if(!Profit_Order){
      CreateTextLable("Trade_No3","No trails active at the moment.......waiting",Yellow,0,120);
      return;
   }
   CreateTextLable("Trade_No3","Ticket #         Pair          Trail Start Time",Text_Color,0,120);
   CreateTextLable("Trade_No4","_______________________________________________",Text_Color,0,122);
   CreateTextLable("Trade_No5"," Trail %    Locked Pips",Text_Color,230,120);
   CreateTextLable("Trade_No6","______________________",Text_Color,240,122);
   int line_cnt=0;
   for(t = 0;t<ArrayRange(Trade_Info,0);t++){
      label_name = StringConcatenate("Trade_Show",t);
      label_name2 = StringConcatenate("Trade_Show2",t);
      label_name3 = StringConcatenate("Trade_Show3",t);
      label_name4 = StringConcatenate("Trade_Show4",t);
      if(Trade_Info[t][1]==0)continue;
      CreateTextLable(label_name,Trade_Info[t][0] + "   " + Get_Symbol(Trade_Info[t][0]) + "              " + TimeToStr(Trade_Info[t][1],TIME_MINUTES),Text_Color,0,140+(line_cnt*20));
      l_Trail_Percent = Get_Trail_Percent(OrderTicket(),OrderSymbol());
      CreateTextLable(label_name2,DoubleToStr(l_Trail_Percent,0) + "%                " + DoubleToStr(Get_Safe_Pips(Trade_Info[t][0]),1),Text_Color,240,140+(line_cnt*20));
      
      line_cnt++;
   }
   CreateTextLable("My_Pips","Total Safe Pips : " + DoubleToStr(Locked_Pips(),1),LawnGreen,0,140+(line_cnt*20));
//----

   return(0);
  }
//+------------------------------------------------------------------+
void Clean_Up()
{
string 
   label_name,
   label_name2,
   label_name3,
   label_name4;
   ObjectDelete(ID + "Trade_No3");
   ObjectDelete(ID + "Trade_No4");
   ObjectDelete(ID + "Trade_No5");
   ObjectDelete(ID + "Trade_No6");
   ObjectDelete(ID + "My_Pips");
   DeleteExistingTradeLabels("Trade_Show");
}
//+------------------------------------------------------------------+

int Trade_Count()
{
int
   counter = 0;
   for(int i = OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(Own_Symbol_Only){
         if(OrderSymbol()!=Symbol())continue;
      }
      if(OrderMagicNumber()==MagicNumber||MagicNumber==-1)counter++;
   }
   return(counter);
}
//+------------------------------------------------------------------+
void CreateTextLable(string TextLableName,string Text,color l_Text_Color,int X,int Y)
{ 
int
   TextSize = 10,
   Corner = 0;
string 
   myLabelName = ID + TextLableName;
   if(TextLableName=="Heading")TextSize = 15;
   ObjectCreate(myLabelName, OBJ_LABEL, 0, TimeCurrent(), 0);
   ObjectSet(myLabelName, OBJPROP_CORNER, Corner);
   ObjectSet(myLabelName, OBJPROP_XDISTANCE, X);
   ObjectSet(myLabelName, OBJPROP_YDISTANCE, Y);
   ObjectSetText(myLabelName,Text,TextSize,"New Times Roman",l_Text_Color);
}
//+------------------------------------------------------------------+
void Permanent_Display()
{
   Text_Color = White;
   CreateTextLable("Heading","Compuforex Trailing Stop EA",Text_Color,0,10);
   CreateTextLable("Underline1","_____________________________________",Text_Color,0,20);
   if(Own_Symbol_Only)CreateTextLable("Pairs","Managing " + Symbol() + " Trades ONLY.",Text_Color,0,40);
   else CreateTextLable("Pairs","Managing Trade on ALL pairs",Text_Color,0,40);
   if(MagicNumber==-1)CreateTextLable("Magic_No","Managing trades with ANY MagicNumber",Text_Color,0,60);
   else CreateTextLable("Magic_No","Managing trades ONLY with MagicNumber : " + MagicNumber,Text_Color,0,60);
}
//+------------------------------------------------------------------+ 
double Locked_Pips()
{
double
   Pips = 0,
   l_Pip;
   for(int i = OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(Own_Symbol_Only){
         if(OrderSymbol()!=Symbol())continue;
      }
      l_Pip = MarketInfo(OrderSymbol(),MODE_POINT)*D_Factor;
      //Print("l_Pip = " + l_Pip);
      if(OrderMagicNumber()==MagicNumber||MagicNumber==-1){
         if(Profit_Time(OrderTicket())>0){
            if(OrderStopLoss()==0)continue;
            if(OrderType()==OP_BUY)Pips += (OrderStopLoss()-OrderOpenPrice())/l_Pip;
            if(OrderType()==OP_SELL)Pips += (OrderOpenPrice() - OrderStopLoss())/l_Pip;
         }
      }
   }
   return(Pips);
}
//+------------------------------------------------------------------+
void Add_Ticket()
{
int
   OrderCount = ArrayResize(Trade_Info,ArrayRange(Trade_Info,0)+1)/4;
   Trade_Info[ArrayRange(Trade_Info,0)-1][0] = Get_New_Ticket();
   Trade_Info[ArrayRange(Trade_Info,0)-1][1] = 0;
   Trade_Info[ArrayRange(Trade_Info,0)-1][2] = 0;
   Trade_Info[ArrayRange(Trade_Info,0)-1][3] = 0;
   Save_Orders();
}
//+------------------------------------------------------------------+
int Delete_Ticket()
{  
   if(!OrdersTotal()){
      ArrayResize(Trade_Info,0);
      return;
   }
bool
   Found_It;
int 
   Temp_Array[][4],
   Missing_Ticket,
   Order_Cnt=0;
   //ArrayResize(Temp_Array,OrdersTotal());
   for(int y = OrdersTotal()-1;y>=0;y--){
      Found_It = true;
      OrderSelect(y,SELECT_BY_POS);
      for(int x = ArrayRange(Trade_Info,0)-1;x>=0;x--){
         if(OrderTicket()==Trade_Info[x][0]){
            Found_It = true;
            ArrayResize(Temp_Array,Order_Cnt+1);
            Temp_Array[Order_Cnt][0] = Trade_Info[x][0];
            Temp_Array[Order_Cnt][1] = Trade_Info[x][1];
            Temp_Array[Order_Cnt][2] = Trade_Info[x][2];
            Temp_Array[Order_Cnt][3] = Trade_Info[x][3];
            Order_Cnt++;
        }
     }
    // if(!Found_It&&x>=0)Missing_Ticket = Trade_Info[x][0];
   }
   //Print("ArrayRange(Temp_Array,0) = " + ArrayRange(Temp_Array,0));
   ArrayResize(Trade_Info,ArrayRange(Temp_Array,0));
   
   if(ArrayRange(Temp_Array,0)==0){
      Save_Orders();
      return(0);
   }
   ArrayCopy(Trade_Info,Temp_Array);
   Save_Orders();

   //Print("Ticket #" + Missing_Ticket + " Deleted from file.");
   return(Found_It);
}
//+------------------------------------------------------------------+
void Update_Info(int l_Ticket)
{
   for(int x = ArrayRange(Trade_Info,0)-1;x>=0;x--){
      if(Trade_Info[x][0]==l_Ticket){
         if(Trade_Info[x][1]==0){
            Trade_Info[x][1] = iTime(Symbol(),0,0);
            PlaySound("alert2.wav");
            return;
         }
      }
   }
   return;
}
//+------------------------------------------------------------------+
bool Create_OrderState()
{
int
   cnt=0;
   ArrayResize(Trade_Info,Trade_Count());
   for (int i = OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(Own_Symbol_Only){
         if(OrderSymbol()!=Symbol())continue;
      }
      if(OrderMagicNumber()==MagicNumber||MagicNumber==-1){
         Trade_Info[i][0]=OrderTicket();
     //    Print("Ticket # " + OrderTicket() + " added to orderstate");
         Trade_Info[i][1]=0;
         Trade_Info[i][2]=0;
         Trade_Info[i][3]=0;
      }
   }
   return(false);
}
//+------------------------------------------------------------------+
int Load_Orders()
{
bool
   Order_OK;
int
   Temp_Orders[][4],
   Order_Cnt=0,
   handle=FileOpen(Orders_Filename, FILE_CSV|FILE_READ);
   if(handle>-1){
      ArrayResize(Temp_Orders,OrdersTotal());
      while(!FileIsEnding(handle)){
         ArrayResize(Trade_Info,Order_Cnt+1);
         Trade_Info[Order_Cnt][0] = StrToInteger(FileReadString(handle));
         Trade_Info[Order_Cnt][1] = StrToInteger(FileReadString(handle));
         Trade_Info[Order_Cnt][2] = StrToInteger(FileReadString(handle));
         Trade_Info[Order_Cnt][3] = StrToInteger(FileReadString(handle));
         Order_Cnt++;
      }
   }   
   ArrayResize(Temp_Orders,Trade_Count());
   FileClose(handle);
   //Print("Previous Order File found.......verifying integrity.");
   if(!Trade_Count()){
      ArrayResize(Trade_Info,0);
      //Print("No trades exist.....Order File discarded.");
      FileDelete(Orders_Filename);
      return(0);
   }
   //Print("Open Orders = " + OrdersTotal() + "/Orders on file = " + ArrayRange(Trade_Info,0));
   Order_Cnt = 0;
   //Print("Checking orders match file........");
   for(int i=0;i<OrdersTotal();i++){
      Order_OK=false;
      OrderSelect(i,SELECT_BY_POS);
      if(Own_Symbol_Only){
         if(OrderSymbol()!=Symbol())continue;
      }
      if(OrderMagicNumber()==MagicNumber||MagicNumber==-1){
         //Print("Checking " + OrderSymbol() + " order with magic number = " + OrderMagicNumber());
         for(int x=0;x<ArrayRange(Trade_Info,0);x++){
            //Print("OrderTicket = " + OrderTicket());
            if(OrderTicket()==Trade_Info[x][0]){
               Temp_Orders[Order_Cnt][0]=Trade_Info[x][0];
               Temp_Orders[Order_Cnt][1]=Trade_Info[x][1];
               Temp_Orders[Order_Cnt][2]=Trade_Info[x][2];
               Temp_Orders[Order_Cnt][3]=Trade_Info[x][3];

               Order_OK=true;
            }
         }
         //Print("Order_OK = " + Order_OK);
         if(!Order_OK){
           // Print("Adding ticket #" + OrderTicket() + " to the orderfile.");
            Temp_Orders[Order_Cnt][0]=OrderTicket();
            Temp_Orders[Order_Cnt][1]=0;
            Temp_Orders[Order_Cnt][2]=0;
            Temp_Orders[Order_Cnt][3]=0;
            //Print("New order discovered....added to file.");
         }
         Order_Cnt++;
      }//if(Magic
      
      
   }//for
   ArrayResize(Trade_Info,ArrayRange(Temp_Orders,0));
   //Print("about to copy temp array. Sizes are = Temp_Array = " + ArrayRange(Temp_Orders,0) + "/Trade_Info = " + ArrayRange(Trade_Info,0));
   ArrayCopy(Trade_Info,Temp_Orders);
   Save_Orders();
   return(ArrayRange(Trade_Info,0));
}
//+------------------------------------------------------------------+
int Save_Orders()
{
int
   handle=FileOpen(Orders_Filename, FILE_CSV|FILE_WRITE,';');
   if(handle>0){
      for(int x=0;x<ArrayRange(Trade_Info,0);x++){
         FileWrite(handle,Trade_Info[x][0],Trade_Info[x][1],Trade_Info[x][2],Trade_Info[x][3]);
      }   
      FileClose(handle);
   }
   return(x);
}
//+------------------------------------------------------------------+
int Profit_Time(int l_Ticket)
{
   for(int y = ArrayRange(Trade_Info,0)-1;y>=0;y--){
      if(Trade_Info[y][0]==l_Ticket)return(Trade_Info[y][1]);
   }
   return(0);
}
//+------------------------------------------------------------------+
double Get_Safe_Pips(int l_Ticket)
{
   OrderSelect(l_Ticket,SELECT_BY_TICKET);
   if(OrderStopLoss()==0)return(0);
   double l_Pip = MarketInfo(OrderSymbol(),MODE_POINT)*D_Factor;
   return(MathAbs(OrderOpenPrice()-OrderStopLoss())/l_Pip);
}
//+------------------------------------------------------------------+
int Get_Trail_Percent(int l_Ticket, string l_Pair)
{
double
   l_Trail_Percent,
   l_Decay_Rate = Decay_Rate;
int
   Bar_Shift;
   if(Profit_Time(l_Ticket)>0)Bar_Shift = iBarShift(l_Pair,0,Profit_Time(l_Ticket))*Period();
   else Bar_Shift=0;
   if(Use_Decay){
      if(Bar_Shift>=Wait_Mins){
         Bar_Shift = Bar_Shift - Wait_Mins;
         if(Exp_Decay)l_Decay_Rate = Bar_Shift * Decay_Rate;
         l_Trail_Percent = Trail_Percent - (Bar_Shift * l_Decay_Rate);
      }
      else l_Trail_Percent = Trail_Percent;
   }
   else l_Trail_Percent = Trail_Percent;
   l_Trail_Percent = MathMax(l_Trail_Percent,Trail_Min);
   //if(Debug)Print("Function Get_Trail_Percent = " + l_Trail_Percent);
   return(l_Trail_Percent);
}
//+------------------------------------------------------------------+

string Get_Symbol(int l_Ticket)
{
   OrderSelect(l_Ticket, SELECT_BY_TICKET);
   return(StringSubstr(OrderSymbol(),0,6));
}
//+------------------------------------------------------------------+
void DeleteExistingLabels()
{
int 
   objLabels = ObjectsTotal();
string 
   objName;
   if (objLabels > 0){
      for (int i = objLabels; i >= 0;i--){
         objName = ObjectName(i);
         if (StringFind(objName, ID , 0) >= 0) ObjectDelete(objName); 
      }
   }
}
//+------------------------------------------------------------------+
void DeleteExistingTradeLabels(string which)
{
int 
   objLabels = ObjectsTotal();
string 
   objName,
   FindWhat = ID + which;
   if (objLabels > 0){
      for (int i = objLabels; i >= 0;i--){
         objName = ObjectName(i);
         if (StringFind(objName, FindWhat , 0) >= 0) ObjectDelete(objName); 
      }
   }
}
//+------------------------------------------------------------------+
void Set_StopLoss()
{
static bool
   Bar_Alert;
int
   err;
double
   My_SL,
   l_buffer,
   l_Max_Buy_SL,
   l_Max_Sell_SL,
   l_Max_SL,
   Pip,
   l_Manual_SL,
   Loss_in_Money=Risk/100 * AccountBalance(),
   Cost_Per_Pip,
   Allowed_PipsLoss,
   l_Min_Mod,
   Auto_Trail_Start;
bool
   mod;
   for (int i = OrdersTotal()-1;i>=0;i--){
      mod=true;
      if(OrderSelect(i,SELECT_BY_POS)){
         if(Own_Symbol_Only){
            if(OrderSymbol()!=Symbol())continue;
         }
         if(Profit_Time(OrderTicket())>0)continue;
         if(TimeCurrent()-OrderOpenTime()<Set_SL_Delay)continue;
         Pip = MarketInfo(OrderSymbol(),MODE_POINT)*D_Factor;
         l_buffer = SL_Buffer * Pip;
         l_Max_SL = SL_Max * Pip;
         l_Manual_SL = Manual_SL * Pip;
         l_Min_Mod = Min_Mod * Pip;
         Cost_Per_Pip = OrderLots() * Dollars_Per_Pip(OrderSymbol());
         Allowed_PipsLoss = (Loss_in_Money/Cost_Per_Pip)*Pip;
         //Print("Loss_in_Money = " + Loss_in_Money);
         //Print("Cost_Per_Pip = " + Cost_Per_Pip);
         //Print("Allowed_PipsLoss = " + Allowed_PipsLoss);
         if(OrderMagicNumber()==MagicNumber||MagicNumber==-1){
            if(Manual_SL==0){
               if(iBars(OrderSymbol(),PERIOD_H1)<SL_Bars){
                  if(!Bar_Alert){
                     Alert(OrderSymbol() + "Not enough bars to calculate SL for hours selected." + "\n"+
                           "SOLUTION : Use fewer hours to calculate SL or download data." + "\n"+
                           "WARNING  : EA will use available data....SL may be inacurate.");
                     Bar_Alert=true;
                  }
               }
            }
            if(!Get_State(OrderTicket())){
               //Print("Get_State(OrderTicket()) = " + Get_State(OrderTicket()));
               if(OrderStopLoss()==0||SL_Overide==true){
                  switch(OrderType()){
                     case OP_BUY  : My_SL = iLow(OrderSymbol(),PERIOD_M5,iLowest(OrderSymbol(),PERIOD_M5,MODE_LOW,SL_Minutes,0))-l_buffer;
                                    //Print("ilow sl = " + My_SL + "/l_Buffer = " + l_buffer);
                                    l_Max_Buy_SL = OrderOpenPrice() - l_Max_SL;
                                    My_SL = MathMax(My_SL,l_Max_Buy_SL);
                                    //Print("l_Max_Buy_SL = " + l_Max_Buy_SL + "/My_SL = " + My_SL);
                                    if(iLowest(OrderSymbol(),PERIOD_M5,MODE_LOW,SL_Minutes,0)==0)My_SL=OrderOpenPrice() - l_Max_SL;
                                    //Print("Point 2..........l_Max_Buy_SL = " + l_Max_Buy_SL + "/My_SL = " + My_SL);
                                    if(Use_RiskPercent_SL)My_SL=OrderOpenPrice() - Allowed_PipsLoss;
                                    if(Manual_SL>0)My_SL = OrderOpenPrice() - l_Manual_SL;
                                    //Print("MathAbs(OrderStopLoss()-My_SL) = " + MathAbs(OrderStopLoss()-My_SL) + "/l_Min_Mod = " + l_Min_Mod);
                                    if(MathAbs(OrderStopLoss()-My_SL)>l_Min_Mod)mod = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(My_SL,MarketInfo(OrderSymbol(),MODE_DIGITS)),OrderTakeProfit(),0,CLR_NONE);
                                    //Print("mod = " + mod);
                                    if(!mod){
                                       err = GetLastError();
                                       Print(Symbol() + " Error setting Stoploss in Set_StopLoss function - error " + err+" - " + ErrorDescription(err));
                                    }
                                    else Update_OrderState(OrderTicket(),2,true);
                                    break;
                              
                     case OP_SELL : My_SL = iHigh(OrderSymbol(),PERIOD_M5,iHighest(OrderSymbol(),PERIOD_M5,MODE_HIGH,SL_Minutes,0))+l_buffer;
                                    //Print("ihigh sl = " + My_SL + "/l_Buffer = " + l_buffer);
                                    l_Max_Sell_SL = OrderOpenPrice() + l_Max_SL;
                                    My_SL = MathMin(My_SL,l_Max_Sell_SL);
                                    if(iHighest(OrderSymbol(),PERIOD_M5,MODE_HIGH,SL_Bars,0)==0)My_SL= OrderOpenPrice() + l_Max_SL;
                                    //Print("l_Max_Sell_SL = " + l_Max_Sell_SL + "/My_SL = " + My_SL);
                                    if(Use_RiskPercent_SL)My_SL=OrderOpenPrice() + Allowed_PipsLoss;
                                    if(Manual_SL>0)My_SL = OrderOpenPrice() + l_Manual_SL;
                                    //Print("MathAbs(OrderStopLoss()-My_SL) = " + MathAbs(OrderStopLoss()-My_SL) + "/l_Min_Mod = " + l_Min_Mod);
                                    if(MathAbs(OrderStopLoss()-My_SL)>l_Min_Mod)mod = OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(My_SL,MarketInfo(OrderSymbol(),MODE_DIGITS)),OrderTakeProfit(),0,CLR_NONE);
                                    //Print("mod = " + mod);
                                    if(!mod){
                                       err = GetLastError();
                                       Print(Symbol() + " Error setting Stoploss in Set_StopLoss function - error " + err+" - " + ErrorDescription(err));
                                    }
                                    else Update_OrderState(OrderTicket(),2,true);
                                    break;
                  }
               
               }
            }
         }
      }
      else {
         err = GetLastError();
         Print("Error selecting order - " + GetLastError()+ " " + ErrorDescription(err));
      }
   }
}
//+------------------------------------------------------------------+
double Dollars_Per_Pip(string l_Pair)
{
double
   PipSize = MarketInfo(l_Pair,MODE_TICKSIZE)*D_Factor;
   PipSize = PipSize * MarketInfo(l_Pair,MODE_LOTSIZE);
   //Print("Pipsize = " + PipSize);
   return(PipSize);
}
//+------------------------------------------------------------------+
bool Get_State(int ticket)
{
   for(int y = ArrayRange(Trade_Info,0)-1;y>=0;y--){
      if(Trade_Info[y][0]==ticket){
         //Print("Trade_Info[y][2] = " + Trade_Info[y][2]);
         return(Trade_Info[y][2]);
      }
   }
   return(false);
}
//+------------------------------------------------------------------+
void Update_OrderState(int ticket, int Aspect, int result)
{
   //Print("Updating orderstate of ticket # " + ticket);
   for(int x = ArrayRange(Trade_Info,0)-1;x>=0;x--){
      if(Trade_Info[x][0]==ticket){
         Trade_Info[x][Aspect] = result;
         //Print("Trade_Info[x][Aspect] = " + Trade_Info[x][Aspect]);
         return;
      }
   }
   return;
}
//+------------------------------------------------------------------+
int Get_New_Ticket()
{
int
   Ticket_Time=0,
   Last_Ticket=0;
   for(int i=OrdersTotal()-1;i>=0;i--){
      OrderSelect(i,SELECT_BY_POS);
      if(OrderOpenTime()>Ticket_Time){
         Ticket_Time=OrderOpenTime();
         Last_Ticket=OrderTicket();
      }
   }
   return(Last_Ticket);
}
//+------------------------------------------------------------------+